#!/bin/zsh

# Copyright 2014 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

declare -A _GET
declare -A _POST
declare -A _REF

cgi_get() {  # parse HTTP GET string
  echo "$QUERY_STRING" |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _GET["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
}

cgi_post() {  # parse HTTP POST string
  sed -u 1q |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    value="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
    if [ -n "$_POST[\"$key\"]" ]; then
      n=0
      while [ -n "$_POST[\"$key$n\"]" ]; do n=$(($n + 1)); done
      _POST["$key$n"]="$value"
    else
      _POST["$key"]="$value"
    fi
    #debug "_POST[$key] => $value"
  done
}

cgi_refdata() { # Parse GET data from referer
  echo "$HTTP_REFERER" |cut -d'?' -f2- |tr '&' '\n' |while read query; do
    key="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\1:')"
    val="$(echo "$query" |sed -r 's:^([a-zA-Z0-9_-]*)=(.*)$:\2:')"
    _REF["$key"]="$(echo -e "$(echo "$val" |sed 's:+: :g;s:%:\\x:g')")"
  done
}
